{
    volVectorField Udm_ = UdmModel->Udm();
    volVectorField Ucm_ = UdmModel->Ucm();
    surfaceScalarField phir(fvc::flux(Udm_));
    
    volScalarField Kdm = 0.5*magSqr(Udm_);
    volScalarField Kcm = 0.5*magSqr(Ucm_);
    volScalarField Cp1 = mixture.thermo1().Cp();
    volScalarField Cp2 = mixture.thermo2().Cp();
    volVectorField sumUkm = (alpha1/Cp1 + alpha2/Cp2) * (alpha1 * Udm_ + alpha2 *Ucm_);

    fvScalarMatrix TEqn
    (
        fvm::ddt(rho, T) + fvm::div(rhoPhi, T) - fvm::Sp(contErr, T)
      + (alpha1/Cp1 + alpha2/Cp2) * (alpha1*rho1*(Cp1-Cp2)* fvm::div(phir,T)) //extraTerm due to drift I
      
      - fvm::laplacian(turbulence.alphaEff(), T)
      + (
             (fvc::ddt(rho, K) + fvc::div(rhoPhi, K))() - contErr*K
          -  fvc::ddt(p)() // divUp()// - contErr/rho*p  // 
          //+  rho()* fvc::ddt(K)() + rho()*fvc::ddt(alpha1*rho1/rho, Kdm)() + rho()*fvc::ddt(alpha2*rho2/rho,Kcm)()
          //+  alpha1()*rho1()*fvc::div(phir, Kdm+Kcm)()

        )
       *(
           //1/(alpha1()*Cp1() + alpha2()*Cp2())
           alpha1()/Cp1() + alpha2()/Cp2()
        )
     ==
        fvOptions(rho, T)
        + (fvc::grad(p) & sumUkm )
        // + fluid.heatTransfer(T)
    );

    TEqn.relax();

    fvOptions.constrain(TEqn);

    TEqn.solve();

    fvOptions.correct(T);

    mixture.correctThermo();
    mixture.correct();
}
